
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;


public class NewJFrame extends javax.swing.JFrame {

    Connection conn;
    ArrayList<SanPham> alSanPham;

    public NewJFrame() throws SQLException {
        initComponents();
        setVisible(true);
        setLocationRelativeTo(null);

        conn = DriverManager.getConnection(
                "jdbc:sqlserver://localhost:1433;databaseName=lab56_qlsp",
                "sa",
                "thien1107"
        );

        alSanPham = getSanPhamInDB();
        updateTable(alSanPham);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("quan ly san pham");

        jLabel6.setText("ma sp");

        jLabel7.setText("ten sp");

        jLabel8.setText("ngay nhap");

        jLabel9.setText("so luong");

        jButton1.setText("add");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("update");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("delete");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("clear");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "id", "ten sp", "ma sp", "ngay nhap", "so luong"
            }
        ));
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9)
                    .addComponent(jLabel8)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addGap(70, 70, 70)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, 171, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton4)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 436, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(182, 182, 182)
                        .addComponent(jLabel1)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButton1, jButton2, jButton3, jButton4});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel6)
                            .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel8))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel9)
                            .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(7, 7, 7)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 118, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        clearForm();
        JOptionPane.showMessageDialog(this, "clear form done!");
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (checkForm()) {
            addSanPham(FormToSanPham());
            alSanPham = getSanPhamInDB();
            updateTable(alSanPham);
            JOptionPane.showMessageDialog(this, "add sp thanh cong");
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
        int index = jTable1.getSelectedRow();
        fillDataToForm(alSanPham.get(index));
    }//GEN-LAST:event_jTable1MouseClicked

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        int index = jTable1.getSelectedRow();
        if (index > -1) {
            updateSanPham(alSanPham.get(index).getId(), FormToSanPham());
            alSanPham = getSanPhamInDB();
            updateTable(alSanPham);
            JOptionPane.showMessageDialog(this, "update thanh cong!");
        } else {
            JOptionPane.showMessageDialog(this, "ban phai chon 1 san pham can update");
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        int index = jTable1.getSelectedRow();
        if (index > -1) {
            deleteSanPham(alSanPham.get(index));
            alSanPham = getSanPhamInDB();
            updateTable(alSanPham);
            JOptionPane.showMessageDialog(this, "delete sp thanh cong!");
        } else {
            JOptionPane.showMessageDialog(this, "ban phai chon 1 sp de delete");
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    public void fillDataToForm(SanPham sanPham) {
        jTextField5.setText(sanPham.getTen());
        jTextField6.setText(sanPham.getMa());
        jTextField7.setText(sanPham.getNgayNhap());
        jTextField8.setText(sanPham.getSoLuong() + "");
    }

    public boolean deleteSanPham(SanPham sanPham) {
        try {
            PreparedStatement preparedStatement = conn.prepareStatement("DELETE FROM san_pham WHERE id=?");
            preparedStatement.setInt(1, sanPham.getId());
            preparedStatement.execute();
        } catch (Exception e) {
        }
        return true;
    }

    public boolean updateSanPham(int id, SanPham sanPham) {
        try {
            PreparedStatement preparedStatement = conn.prepareStatement("UPDATE san_pham SET ten=?, ma_sp=?, ngay_nhap=?, so_luong=? WHERE id=?");
            preparedStatement.setString(1, sanPham.getTen());
            preparedStatement.setString(2, sanPham.getMa());
            preparedStatement.setString(3, sanPham.getNgayNhap());
            preparedStatement.setInt(4, sanPham.getSoLuong());
            preparedStatement.setInt(5, id);
            preparedStatement.execute();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return true;
    }

    public boolean addSanPham(SanPham sanPham) {
        try {
            PreparedStatement preparedStatement = conn.prepareStatement("INSERT INTO san_pham(ten, ma_sp, ngay_nhap, so_luong) VALUES(?, ?, ?, ?);");
            preparedStatement.setString(1, sanPham.getTen());
            preparedStatement.setString(2, sanPham.getMa());
            preparedStatement.setString(3, sanPham.getNgayNhap());
            preparedStatement.setInt(4, sanPham.getSoLuong());
            preparedStatement.execute();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return true;
    }

    public SanPham FormToSanPham() {
        return new SanPham(
                -1,
                jTextField5.getText(),
                jTextField6.getText(),
                jTextField7.getText(),
                Integer.parseInt(jTextField8.getText())
        );
    }

    public ArrayList<SanPham> getSanPhamInDB() {
        ArrayList<SanPham> alSP = new ArrayList<>();
        PreparedStatement preparedStatement;
        try {
            preparedStatement = conn.prepareStatement("SELECT * FROM san_pham");
            ResultSet resultSet = preparedStatement.executeQuery();
            while (resultSet.next()) {
                alSP.add(
                        new SanPham(
                                resultSet.getInt("id"),
                                resultSet.getString("ten"),
                                resultSet.getString("ma_sp"),
                                resultSet.getString("ngay_nhap"),
                                resultSet.getInt("so_luong")
                        )
                );
            }
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
        return alSP;
    }

    public void updateTable(ArrayList<SanPham> alSP) {
        DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
        model.setRowCount(0);
        alSP.forEach((sanPham) -> {
            model.addRow(sanPham.toArray());
        });
    }

    public boolean checkForm() {
        if (jTextField5.getText().length() == 0) {
            JOptionPane.showMessageDialog(this, "ten sp ko ddc trong");
            return false;
        }
        try {
            new SimpleDateFormat("dd-mm-YYYY").parse(jTextField7.getText());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "ngay thang khong hop le");
        }
        if (jTextField7.getText().length() == 0) {
            JOptionPane.showMessageDialog(this, "ngay nhap ko ddc trong");
            return false;
        }
        try {
            int sl = Integer.parseInt(jTextField8.getText());
            if (sl < 0) {
                JOptionPane.showMessageDialog(this, "sl phai lon hon 0");
                return false;
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "sl khog hop le");
            return false;
        }
        return true;
    }

    public void clearForm() {
        jTextField6.setText("");
        jTextField5.setText("");
        jTextField7.setText("");
        jTextField8.setText("");
    }

    public static void main(String args[]) {
        try {
            NewJFrame newJframe = new NewJFrame();
        } catch (SQLException ex) {
            JOptionPane.showMessageDialog(null, "Không thể kết nối đến DB\nLỗi: " + ex.toString());
            System.exit(0);
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    // End of variables declaration//GEN-END:variables
}
